liblogging: beepmessage.c File Reference

Main Page | Compound List | File List | Compound Members | File Members | Related Pages

# beepmessage.c File Reference

Implementation of the BEEP Message Object. More...

`#include <assert.h>`
`#include "config.h"`
`#include "liblogging.h"`
`#include "beepmessage.h"`
`#include "beepframe.h"`

## Functions
char * | sbMesgGetRawBuf (sbMesgObj *pThis)
| return the raw buffer object
int | sbMesgGetMIMEHdrSize (sbMesgObj *pThis)
| return the size of the MIME Header (in bytes)
int | sbMesgGetPayloadSize (sbMesgObj *pThis)
| return the size of the actual payload (in bytes)
int | sbMesgGetOverallSize (sbMesgObj *pThis)
| return the overall message size (in bytes)
sbMesgObj * | sbMesgConstruct (char *pszMIMEHdr, char *pszPayload)
| Constructor to create a Mesg based on provided values.
srRetVal | sbMIMEExtract (char *pszInBuf, int iInBufLen, char **pszMIMEHdr, char **pszPayload)
| Extract MIME header and body from a given message buffer.
sbMesgObj * | sbMesgRecvMesg (sbChanObj *pChan)
| Receive a message from a given channel.
sbMesgObj * | sbMesgConstrFromFrame (sbFramObj *psbFram)
srRetVal | sbMesgSendMesgWithCallback (sbMesgObj *pThis, sbChanObj *pChan, char *pszCmd, SBansno uAnsno, void(*OnFramDestroy)(sbFramObj *), void *pUsr)
srRetVal | sbMesgSendMesg (sbMesgObj *pThis, sbChanObj *pChan, char *pszCmd, SBansno uAnsno)
| The same as sbMesgSendMesgWithCallback, except that no callback is provided.
void | sbMesgDestroy (sbMesgObj *pThis)
| Destructor.

## Detailed Description

Implementation of the BEEP Message Object.

Author:
  Rainer Gerhards <rgerhards@adiscon.com>

Date:
  2003-08-04

Copyright 2002-2003 Rainer Gerhards and Adiscon GmbH. All Rights Reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

* Neither the name of Adiscon GmbH or Rainer Gerhards nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

## Function Documentation

sbMesgObj* sbMesgConstruct | ( | char * | pszMIMEHdr,
|  | char * | pszPayload
| ) |

  | Constructor to create a Mesg based on provided values. with no MIME headers. Parameters:
  szMIMEHdr | [in] buffer to MIME headers. Is copied to private buffer space. May be NULL, in which case no MIME headers are present.
  szPayload | [in] buffer to payload data. Is copied to private buffer. May be NULL, in which case an empty payload is created after the MIME header.
  Return values:
  Pointer | to new message object or NULL if an error occured.

void sbMesgDestroy | ( | sbMesgObj * | pThis | ) |

| Destructor. Does not return any value as the primary function to be used is free() which itself does not return any status.

sbMesgObj* sbMesgRecvMesg | ( | sbChanObj * |  | ) |

  | Receive a message from a given channel. As we do not currently support fragmentation, this method simply reads a single fram off the socket and uses that frame to construct the message. Return values:
  Pointer | to newly constructed MesgObj or NULL if an error occured.

srRetVal sbMesgSendMesgWithCallback | ( | sbMesgObj * | pThis,
|  | sbChanObj * | pChan,
|  | char * | pszCmd,
|  | SBansno | uAnsno,
|  | void(* | OnFramDestroy)(sbFramObj *),
|  | void * | pUsr
| ) |

| For now, we assume a Mesg will always fit into one Fram. This is always true for syslog. So there is no need to do it more complicated. In the long term, it may be worth changing this...

srRetVal sbMIMEExtract | ( | char * | pszInBuf,
|  | int | iInBufLen,
|  | char ** | pszMIMEHdr,
|  | char ** | pszPayload
| ) |

| Extract MIME header and body from a given message buffer. Todo: handle empty string